import { useSlots as ct, onMounted as Ee, computed as C, ref as g, watch as dt, onBeforeUnmount as vt, createElementBlock as y, openBlock as v, unref as m, normalizeStyle as L, normalizeClass as pe, createBlock as q, createCommentVNode as _, createElementVNode as O, createVNode as ge, createSlots as ht, withCtx as x, renderSlot as $, normalizeProps as X, guardReactiveProps as j, Fragment as ue, renderList as me, mergeProps as Ge, createTextVNode as ie, toDisplayString as Y, withModifiers as ft, nextTick as pt } from "vue";
import { u as gt, c as qe, t as mt, p as S, a as yt, b as bt, o as kt, e as wt, d as ce, i as de, f as le, X as Ct, l as Xe, G as je, x as Ye, q as $t, r as xt, y as Tt } from "./index-jVWdGfFl.js";
import { _ as _t } from "./Title-6BRNasyb.js";
import { u as Ot, U as St } from "./usePrinter-BI95cSFJ.js";
import { _ as It } from "./Tooltip-BUPxcljs.js";
import { L as Nt } from "./Legend-BVtJaKHS.js";
import zt from "./vue-ui-skeleton-Dsd0bx0Y.js";
import { D as At } from "./DataTable-CrhPpuOy.js";
import Pt from "./vue-ui-accordion-DOBMerZl.js";
import { t as Ft, u as Rt } from "./useResponsive-vZgZwV-S.js";
import { u as Ze } from "./useNestedProp-BN5jbfiQ.js";
import { _ as Lt } from "./PackageVersion-DJu8NH8u.js";
import { P as Dt } from "./PenAndPaper-DC3X33rh.js";
import { u as Mt } from "./useUserOptionState-BIvW1Kz7.js";
import { u as Vt } from "./useChartAccessibility-BWojgys7.js";
import Bt from "./BaseIcon-DywZoZmD.js";
import { _ as Ut } from "./_plugin-vue_export-helper-CHgC5LLL.js";
function Je(n, u) {
  const r = n.length;
  if (r === 0)
    throw new Error(`Max aspect ratio cannot be computed: ${n} is an empty array`);
  {
    let i = 1 / 0, s = -1 / 0, c = 0;
    for (let h = 0; h < r; h += 1) {
      const f = n[h].normalizedValue;
      f < i && (i = f), f > s && (s = f), c += f;
    }
    return Math.max(
      u ** 2 * s / c ** 2,
      c ** 2 / (u ** 2 * i)
    );
  }
}
function Ke(n) {
  const { xOffset: u, yOffset: r, width: i, height: s } = n;
  return {
    x0: u,
    y0: r,
    x1: u + i,
    y1: r + s
  };
}
function Ht(n, u, r) {
  if (n.length === 0)
    return !0;
  {
    const i = n.concat(u), s = Je(
      n,
      r
    ), c = Je(i, r);
    return s >= c;
  }
}
function Wt(n) {
  const u = [], r = n.length;
  for (let i = 0; i < r; i += 1) {
    const s = n[i], c = s.length;
    for (let d = 0; d < c; d += 1)
      u.push(s[d]);
  }
  return u;
}
function Et(n, u) {
  const r = {
    ...u,
    children: n
  };
  return et(r);
}
function Gt(n) {
  return (n.x1 - n.x0) * (n.y1 - n.y0);
}
function Qe(n, u) {
  const { width: r, height: i, xOffset: s, yOffset: c } = ye(u), d = n.length, h = n.map((k) => k.normalizedValue || 0).reduce((k, b) => k + b, 0), f = h / i, z = h / r;
  let I = s, A = c;
  const w = [];
  if (r >= i) {
    for (let k = 0; k < d; k += 1) {
      const b = n[k], T = A + b.normalizedValue / f, M = {
        x0: I,
        y0: A,
        x1: I + f,
        y1: T
      }, P = Object.assign({}, b, M);
      A = T, w.push(P);
    }
    return w;
  } else {
    for (let k = 0; k < d; k += 1) {
      const b = n[k], T = I + b.normalizedValue / z, M = {
        x0: I,
        y0: A,
        x1: T,
        y1: A + z
      }, P = Object.assign({}, b, M);
      I = T, w.push(P);
    }
    return w;
  }
}
function qt(n) {
  const u = ye(n), r = u.width, i = u.height;
  return Math.min(r, i);
}
function Xt(n, u) {
  const r = n.length, i = n.map((f) => f.value ?? 0).reduce((f, z) => f + z, 0), s = u / i, c = [];
  let d, h;
  for (let f = 0; f < r; f += 1)
    h = n[f], d = Object.assign({}, h, {
      normalizedValue: h.value * (s || 0)
    }), c.push(d);
  return c;
}
function ye(n) {
  const { x0: u, y0: r, x1: i, y1: s } = n;
  return {
    xOffset: u,
    yOffset: r,
    width: i - u,
    height: s - r
  };
}
function jt(n, u, r, i) {
  let s = n, c = u, d = r, h = i;
  for (; ; ) {
    const f = s.length;
    if (f === 0) {
      const w = Qe(c, d);
      return h.concat(w);
    }
    const z = qt(d), I = s[0], A = s.slice(1, f);
    if (Ht(c, I, z)) {
      const w = c.concat(I);
      s = A, c = w, d = d, h = h;
    } else {
      const w = c.length;
      let k = 0;
      for (let P = 0; P < w; P += 1)
        k += c[P].normalizedValue;
      const b = Yt(d, k), T = Qe(c, d), M = h.concat(T);
      s = s, c = [], d = b, h = M;
    }
  }
}
function et(n) {
  if (typeof n.children > "u" || !n.children.length)
    return [n];
  {
    const u = Xt(
      n.children,
      Gt(n)
    ), r = jt(u, [], n, []), i = r.length, s = [];
    for (let d = 0; d < i; d += 1)
      s.push(et(r[d]));
    return Wt(s);
  }
}
function Yt(n, u) {
  const { width: r, height: i, xOffset: s, yOffset: c } = ye(n);
  if (r >= i) {
    const d = u / i, h = r - d, f = {
      xOffset: s + d,
      yOffset: c,
      width: h,
      height: i
    };
    return Ke(f);
  } else {
    const d = u / r, h = i - d, f = {
      xOffset: s,
      yOffset: c + d,
      width: r,
      height: h
    };
    return Ke(f);
  }
}
const Zt = ["id"], Jt = {
  key: 4,
  class: "vue-ui-treemap-breadcrumbs",
  "data-html2canvas-ignore": ""
}, Kt = ["onClick", "data-last-crumb"], Qt = { class: "vue-ui-treemap-crumb-unit" }, el = { class: "vue-ui-treemap-crumb-unit-label" }, tl = {
  key: 0,
  style: { width: "24px", display: "flex", "align-items": "center" }
}, ll = {
  key: 0,
  class: "vue-ui-treemap-crumb-unit-arrow"
}, ol = ["xmlns", "viewBox"], al = { key: 0 }, nl = ["id"], sl = ["stop-color"], rl = ["stop-color"], ul = ["x", "y", "height", "width", "fill", "rx", "stroke", "stroke-width", "onClick", "onMouseenter"], il = ["x", "y", "height", "width"], cl = {
  style: { width: "100%", height: "100%" },
  class: "vue-ui-treemap-cell"
}, dl = {
  key: 6,
  class: "vue-data-ui-watermark"
}, vl = ["onClick"], hl = { key: 0 }, fl = { key: 1 }, pl = ["innerHTML"], gl = {
  __name: "vue-ui-treemap",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend", "selectDatapoint"],
  setup(n, { expose: u, emit: r }) {
    const { vue_ui_treemap: i } = gt(), s = n, c = r, d = ct();
    Ee(() => {
      d["chart-background"] && console.warn("VueUiTreemap does not support the #chart-background slot.");
    });
    const h = C(() => !!s.dataset && s.dataset.length), f = C(() => /^((?!chrome|android).)*safari/i.test(navigator.userAgent)), z = g(qe()), I = g(!1), A = g(""), w = g(!1), k = g(0), b = g([]), T = g(null), M = g(null), P = g(null), be = g(null), ke = g(null), we = g(0), Ce = g(0), $e = g(0), e = C({
      get: () => Oe(),
      set: (t) => t
    }), { userOptionsVisible: ve, setUserOptionsVisibility: xe, keepUserOptionState: Te } = Mt({ config: e.value }), { svgRef: _e } = Vt({ config: e.value.style.chart.title });
    function Oe() {
      const t = Ze({
        userConfig: s.config,
        defaultConfig: i
      });
      return t.theme ? {
        ...Ze({
          userConfig: yt.vue_ui_treemap[t.theme] || s.config,
          defaultConfig: t
        }),
        customPalette: mt[t.theme] || S
      } : t;
    }
    dt(() => s.config, (t) => {
      e.value = Oe(), ve.value = !e.value.userOptions.showOnChartHover, we.value += 1, Ce.value += 1, $e.value += 1, F.value.showTable = e.value.table.show, F.value.showTooltip = e.value.style.chart.tooltip.show;
    }, { deep: !0 });
    const { isPrinting: Se, isImaging: Ie, generatePdf: Ne, generateImage: ze } = Ot({
      elementId: `treemap_${z.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-treemap",
      options: e.value.userOptions.print
    }), tt = C(() => e.value.userOptions.show && !e.value.style.chart.title.text), oe = C(() => bt(e.value.customPalette)), F = g({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), V = g({
      height: e.value.style.chart.height,
      width: e.value.style.chart.width
    }), W = C(() => ({
      bottom: V.value.height - e.value.style.chart.padding.bottom,
      height: V.value.height - e.value.style.chart.padding.top - e.value.style.chart.padding.bottom,
      left: e.value.style.chart.padding.left,
      right: V.value.width - e.value.style.chart.padding.right,
      top: e.value.style.chart.padding.top,
      vbHeight: V.value.height,
      vbWidth: V.value.width,
      width: V.value.width - e.value.style.chart.padding.left - e.value.style.chart.padding.right
    }));
    function Ae(t) {
      t.forEach((o, l) => {
        o.id = qe(), o.color = ce(o.color) || oe.value[l] || S[l] || S[l % S.length], o.children && (o.children.forEach((a) => {
          a.parentId = o.id, a.color = o.color;
        }), Ae(o.children));
      });
    }
    const B = g(s.dataset), ae = g(null);
    Ee(() => {
      lt();
    });
    function lt() {
      if (kt(s.dataset) && wt({
        componentName: "VueUiTreemap",
        type: "dataset"
      }), Ae(B.value), e.value.responsive) {
        const t = Ft(() => {
          const { width: o, height: l } = Rt({
            chart: T.value,
            title: e.value.style.chart.title.text ? M.value : null,
            legend: e.value.style.chart.legend.show ? P.value : null,
            source: be.value,
            noTitle: ke.value
          });
          requestAnimationFrame(() => {
            V.value.width = o, V.value.height = l;
          });
        });
        ae.value = new ResizeObserver(t), ae.value.observe(T.value.parentNode);
      }
    }
    vt(() => {
      ae.value && ae.value.disconnect();
    });
    const Z = g(B.value), Q = C(() => Z.value.map((t, o) => ({
      ...t,
      color: ce(t.color) || oe.value[o] || S[o] || S[o % S.length]
    })).filter((t) => !b.value.includes(t.id))), J = C(() => B.value.filter((t) => !b.value.includes(t.id)).map((t) => t.value || 0).reduce((t, o) => t + o, 0)), Pe = C({
      get() {
        let t = [...Q.value];
        return e.value.style.chart.layout.sorted && (t = [...Q.value].sort((o, l) => l.value - o.value)), t.map((o) => ({
          ...o
        }));
      },
      set(t) {
        return t;
      }
    });
    function Fe(t, o) {
      return t.value / o;
    }
    function ot(t, o, l) {
      const a = e.value.style.chart.layout.rects.colorRatio - Fe(o, l);
      return Xe(t, a < 0 ? 0 : a);
    }
    function Re(t, o, l, a) {
      return t.map((p, H) => {
        const re = ot(ce(o) || oe.value[H] || S[H] || S[H % S.length], p, a), it = Fe(p, a);
        return {
          ...p,
          color: re,
          proportion: it,
          parentName: l,
          children: p.children ? Re(p.children, re, p.name, a) : void 0
        };
      });
    }
    const ee = C(() => Et(
      Pe.value.map((t, o) => {
        const l = t.children ? t.children.reduce((a, p) => a + p.value, 0) : t.value;
        return {
          value: t.value,
          id: t.id,
          children: t.children ? Re(t.children.sort((a, p) => p.value - a.value), t.color, t.name, l) : void 0,
          color: t.color,
          name: t.name
        };
      }),
      { x0: W.value.left * 2, y0: W.value.top, x1: W.value.width, y1: W.value.height }
    ));
    function Le({ y0: t, y1: o }) {
      return o - t <= 0 ? 1e-4 : o - t;
    }
    function De({ x0: t, x1: o }) {
      return o - t <= 0 ? 1e-4 : o - t;
    }
    function E(t) {
      const o = e.value.style.chart.layout.labels.fontSize * (t.proportion * 2 > 1 ? 1 : t.proportion * 2);
      return o < e.value.style.chart.layout.labels.minFontSize ? e.value.style.chart.layout.labels.minFontSize : o;
    }
    function at(t) {
      w.value = t, k.value += 1;
    }
    const K = C(() => ({
      startX: 0,
      startY: 0,
      width: W.value.vbWidth,
      height: W.value.vbHeight
    }));
    function G(t, o = B.value) {
      for (const l of o) {
        if (l.id === t)
          return l;
        if (l.children) {
          const a = G(t, l.children);
          if (a)
            return a;
        }
      }
      return null;
    }
    const N = g([]), U = C(() => N.value.length > 0);
    function Me(t) {
      var l;
      if (!t) {
        Z.value = B.value.slice(), c("selectDatapoint", void 0), N.value = [];
        return;
      }
      const o = G(t.id);
      if (o && ((l = o.children) != null && l.length))
        N.value.push(o.id), Z.value = o.children.slice(), c("selectDatapoint", t);
      else if (t.parentId) {
        N.value.push(t.parentId);
        const a = G(t.parentId);
        Z.value = a.children.slice(), c("selectDatapoint", t);
      } else if (N.value.length > 0) {
        N.value.pop();
        const a = N.value[N.value.length - 1];
        if (a) {
          const p = G(a);
          Z.value = p.children.slice();
        } else
          Z.value = B.value.slice(), N.value = [], c("selectDatapoint", void 0);
      }
    }
    function nt(t) {
      var l;
      const o = G(t.id);
      return !!((l = o == null ? void 0 : o.children) != null && l.length || t.parentId);
    }
    const te = C(() => {
      const t = [
        { id: null, label: "All" }
      ];
      if (N.value.length > 0) {
        let o = G(N.value[N.value.length - 1]);
        const l = [];
        for (; o; )
          l.unshift(o), o = o.parentId ? G(o.parentId) : null;
        for (const a of l)
          t.push({
            id: a.id,
            label: a.name,
            node: a
          });
      }
      return t;
    }), R = g(null), Ve = C(() => B.value.map((t, o) => ({
      ...t,
      color: ce(t.color) || oe.value[o] || S[o] || S[o % S.length],
      shape: "square"
    })).sort((t, o) => o.value - t.value).map((t, o) => ({
      ...t,
      proportion: t.value / B.value.map((l) => l.value).reduce((l, a) => l + a, 0),
      opacity: b.value.includes(t.id) ? 0.5 : 1
    }))), st = C(() => ({
      cy: "treemap-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    }));
    function Be(t) {
      U.value = !1, R.value = null, b.value.includes(t.id) ? b.value = b.value.filter((o) => o !== t.id) : b.value.length < s.dataset.length - 1 && b.value.push(t.id), c("selectLegend", Pe.value);
    }
    const he = g(null);
    function rt({ datapoint: t, seriesIndex: o }) {
      R.value = t, he.value = { datapoint: t, seriesIndex: o, config: e.value, series: Q.value };
      const l = e.value.style.chart.tooltip.customFormat;
      if (Ye(l) && Tt(() => l({
        seriesIndex: o,
        datapoint: t,
        series: Q.value,
        config: e.value
      })))
        A.value = l({
          seriesIndex: o,
          datapoint: t,
          series: Q.value,
          config: e.value
        });
      else {
        let a = "";
        a += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;">${t.name}</div>`, a += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" height="12" width="12" stroke="none" fill="${t.color}"/></svg>`, a += `<b>${de(
          e.value.style.chart.layout.labels.formatter,
          t.value,
          le({
            p: e.value.style.chart.layout.labels.prefix,
            v: t.value,
            s: e.value.style.chart.layout.labels.suffix,
            r: e.value.style.chart.tooltip.roundingValue
          }),
          { datapoint: t, seriesIndex: o }
        )}</b>`, A.value = `<div>${a}</div>`;
      }
      I.value = !0;
    }
    const D = C(() => {
      const t = ee.value.map((l) => ({
        name: l.name,
        color: l.color
      })), o = ee.value.map((l) => l.value);
      return { head: t, body: o };
    });
    function Ue() {
      pt(() => {
        const t = D.value.head.map((a, p) => [[
          a.name
        ], [D.value.body[p]], [isNaN(D.value.body[p] / J.value) ? "-" : D.value.body[p] / J.value * 100]]), o = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], ["val"], ["%"]]].concat(t), l = $t(o);
        xt({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-treemap" });
      });
    }
    const ne = C(() => {
      const t = [
        e.value.table.columnNames.series,
        e.value.table.columnNames.value,
        e.value.table.columnNames.percentage
      ], o = D.value.head.map((p, H) => {
        const re = de(
          e.value.style.chart.layout.labels.formatter,
          D.value.body[H],
          le({
            p: e.value.style.chart.layout.labels.prefix,
            v: D.value.body[H],
            s: e.value.style.chart.layout.labels.suffix,
            r: e.value.table.td.roundingValue
          })
        );
        return [
          {
            color: p.color,
            name: p.name,
            shape: "square"
          },
          re,
          isNaN(D.value.body[H] / J.value) ? "-" : le({
            v: D.value.body[H] / J.value * 100,
            s: "%",
            r: e.value.table.td.roundingPercentage
          })
        ];
      }), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.series,
          e.value.table.columnNames.value
        ],
        head: t,
        body: o,
        config: l
      };
    });
    function ut() {
      return ee.value;
    }
    function He() {
      F.value.showTable = !F.value.showTable;
    }
    function We() {
      F.value.showTooltip = !F.value.showTooltip;
    }
    const se = g(!1);
    function fe() {
      se.value = !se.value;
    }
    return u({
      getData: ut,
      generateCsv: Ue,
      generateImage: ze,
      generatePdf: Ne,
      toggleTable: He,
      toggleTooltip: We,
      toggleAnnotator: fe
    }), (t, o) => (v(), y("div", {
      ref_key: "treemapChart",
      ref: T,
      class: pe(`vue-ui-treemap ${w.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: L(`font-family:${e.value.style.fontFamily};width:100%; ${e.value.responsive ? "height: 100%;" : ""} text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `treemap_${z.value}`,
      onMouseenter: o[3] || (o[3] = () => m(xe)(!0)),
      onMouseleave: o[4] || (o[4] = () => m(xe)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (v(), q(Dt, {
        key: 0,
        svgRef: m(_e),
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: se.value,
        onClose: fe
      }, null, 8, ["svgRef", "backgroundColor", "color", "active"])) : _("", !0),
      tt.value ? (v(), y("div", {
        key: 1,
        ref_key: "noTitle",
        ref: ke,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : _("", !0),
      e.value.style.chart.title.text ? (v(), y("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: M,
        style: L(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:6px`)
      }, [
        (v(), q(_t, {
          key: `title_${we.value}`,
          config: {
            title: {
              cy: "treemap-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "treemap-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : _("", !0),
      e.value.userOptions.show && h.value && (m(Te) || m(ve)) ? (v(), q(St, {
        ref: "details",
        key: `user_option_${k.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: m(Se),
        isImaging: m(Ie),
        uid: z.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: w.value,
        isTooltip: F.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: T.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: se.value,
        onToggleFullscreen: at,
        onGeneratePdf: m(Ne),
        onGenerateCsv: Ue,
        onGenerateImage: m(ze),
        onToggleTable: He,
        onToggleTooltip: We,
        onToggleAnnotator: fe,
        style: L({
          visibility: m(Te) ? m(ve) ? "visible" : "hidden" : "visible"
        })
      }, ht({ _: 2 }, [
        t.$slots.menuIcon ? {
          name: "menuIcon",
          fn: x(({ isOpen: l, color: a }) => [
            $(t.$slots, "menuIcon", X(j({ isOpen: l, color: a })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: x(() => [
            $(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: x(() => [
            $(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: x(() => [
            $(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: x(() => [
            $(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: x(() => [
            $(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: x(({ toggleFullscreen: l, isFullscreen: a }) => [
            $(t.$slots, "optionFullscreen", X(j({ toggleFullscreen: l, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: x(({ toggleAnnotator: l, isAnnotator: a }) => [
            $(t.$slots, "optionAnnotator", X(j({ toggleAnnotator: l, isAnnotator: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : _("", !0),
      te.value.length > 1 ? (v(), y("nav", Jt, [
        (v(!0), y(ue, null, me(te.value, (l, a) => (v(), y("span", {
          key: l.id || "root",
          onClick: (p) => a === te.value.length - 1 ? () => {
          } : Me(l.node),
          class: "vue-ui-treemap-crumb",
          "data-last-crumb": a === te.value.length - 1,
          style: L({
            color: e.value.style.chart.color
          })
        }, [
          O("span", Qt, [
            O("span", el, [
              $(t.$slots, "breadcrumb-label", Ge({ ref_for: !0 }, { crumb: l, isRoot: a === 0 }), () => [
                a === 0 ? (v(), y("div", tl, [
                  ge(Bt, {
                    name: "home",
                    stroke: e.value.style.chart.color
                  }, null, 8, ["stroke"])
                ])) : (v(), y(ue, { key: 1 }, [
                  ie(Y(l.label), 1)
                ], 64))
              ], !0)
            ]),
            a < te.value.length - 1 ? (v(), y("span", ll, [
              $(t.$slots, "breadcrumb-arrow", {}, () => [
                o[5] || (o[5] = ie(" › "))
              ], !0)
            ])) : _("", !0)
          ])
        ], 12, Kt))), 128))
      ])) : _("", !0),
      h.value ? (v(), y("svg", {
        key: 5,
        ref_key: "svgRef",
        ref: _e,
        xmlns: m(Ct),
        class: pe({ "vue-data-ui-fullscreen--on": w.value, "vue-data-ui-fulscreen--off": !w.value, "vue-data-ui-zoom-plus": !U.value, "vue-data-ui-zoom-minus": U.value }),
        viewBox: `${K.value.startX} ${K.value.startY} ${K.value.width <= 0 ? 10 : K.value.width} ${K.value.height <= 0 ? 10 : K.value.height}`,
        style: L(`max-width:100%; overflow: hidden; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        ge(Lt),
        (v(!0), y(ue, null, me(ee.value, (l, a) => (v(), y("g", null, [
          e.value.style.chart.layout.rects.gradient.show ? (v(), y("defs", al, [
            O("radialGradient", {
              id: `tgrad_${l.id}`,
              gradientTransform: "translate(-1, -1.000001) scale(2, 2)"
            }, [
              O("stop", {
                offset: "18%",
                "stop-color": l.color
              }, null, 8, sl),
              O("stop", {
                offset: "100%",
                "stop-color": m(Xe)(l.color, e.value.style.chart.layout.rects.gradient.intensity / 100)
              }, null, 8, rl)
            ], 8, nl)
          ])) : _("", !0)
        ]))), 256)),
        (v(!0), y(ue, null, me(ee.value, (l, a) => (v(), y("g", null, [
          O("rect", {
            x: l.x0,
            y: l.y0,
            height: Le(l),
            width: De(l),
            fill: f.value ? l.color : e.value.style.chart.layout.rects.gradient.show ? `url(#tgrad_${l.id})` : l.color,
            rx: e.value.style.chart.layout.rects.borderRadius,
            stroke: R.value && R.value.id === l.id ? e.value.style.chart.layout.rects.selected.stroke : e.value.style.chart.layout.rects.stroke,
            "stroke-width": R.value && R.value.id === l.id ? e.value.style.chart.layout.rects.selected.strokeWidth : e.value.style.chart.layout.rects.strokeWidth,
            onClick: ft((p) => Me(l), ["stop"]),
            onMouseenter: () => rt({
              datapoint: l,
              seriesIndex: a
            }),
            onMouseleave: o[0] || (o[0] = (p) => {
              R.value = null, I.value = !1;
            }),
            style: L(`opacity:${R.value ? R.value.id === l.id ? 1 : e.value.style.chart.layout.rects.selected.unselectedOpacity : 1}`),
            class: pe([
              "vue-ui-treemap-rect",
              nt(l) ? "vue-data-ui-zoom-plus" : U.value ? "vue-data-ui-zoom-minus" : ""
            ])
          }, null, 46, ul),
          (v(), y("foreignObject", {
            x: l.x0,
            y: l.y0,
            height: Le(l),
            width: De(l),
            class: "vue-ui-treemap-cell-foreignObject"
          }, [
            O("div", cl, [
              e.value.style.chart.layout.labels.showDefaultLabels && (l.proportion > e.value.style.chart.layout.labels.hideUnderProportion || U.value) ? (v(), y("div", {
                key: 0,
                class: "vue-ui-treemap-cell-default",
                style: L(`width:calc(100% - ${E(l) / 1.5}px);text-align:left;line-height:${E(l) < 14 ? 14 : E(l)}px;padding:${E(l) / 3}px; color:${m(je)(l.color)}`)
              }, [
                O("span", {
                  style: L(`width:100%;font-size:${E(l)}px;`)
                }, Y(l.name), 5),
                o[6] || (o[6] = O("br", null, null, -1)),
                O("span", {
                  style: L(`width:100%;font-size:${E(l)}px;`)
                }, Y(m(de)(
                  e.value.style.chart.layout.labels.formatter,
                  l.value,
                  m(le)({
                    p: e.value.style.chart.layout.labels.prefix,
                    v: l.value,
                    s: e.value.style.chart.layout.labels.suffix,
                    r: e.value.style.chart.layout.labels.rounding
                  }),
                  { datapoint: l }
                )), 5)
              ], 4)) : _("", !0),
              $(t.$slots, "rect", Ge({ ref_for: !0 }, {
                rect: l,
                shouldShow: l.proportion > e.value.style.chart.layout.labels.hideUnderProportion || U.value,
                fontSize: E(l),
                isZoom: U.value,
                textColor: m(je)(l.color)
              }), void 0, !0)
            ])
          ], 8, il))
        ]))), 256)),
        $(t.$slots, "svg", X(j({ svg: W.value, isZoom: U.value, rect: R.value, config: e.value })), void 0, !0)
      ], 14, ol)) : _("", !0),
      t.$slots.watermark ? (v(), y("div", dl, [
        $(t.$slots, "watermark", X(j({ isPrinting: m(Se) || m(Ie) })), void 0, !0)
      ])) : _("", !0),
      h.value ? _("", !0) : (v(), q(zt, {
        key: 7,
        config: {
          type: "treemap",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            treemap: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      O("div", {
        ref_key: "chartLegend",
        ref: P
      }, [
        e.value.style.chart.legend.show ? (v(), q(Nt, {
          key: `legend_${$e.value}`,
          legendSet: Ve.value,
          config: st.value,
          id: `treemap_legend_${z.value}`,
          onClickMarker: o[1] || (o[1] = ({ legend: l }) => Be(l))
        }, {
          item: x(({ legend: l, index: a }) => [
            O("div", {
              onClick: (p) => Be(l),
              style: L(`opacity:${b.value.includes(l.id) ? 0.5 : 1}`)
            }, [
              ie(Y(l.name) + ": " + Y(m(de)(
                e.value.style.chart.layout.labels.formatter,
                l.value,
                m(le)({
                  p: e.value.style.chart.layout.labels.prefix,
                  v: l.value,
                  s: e.value.style.chart.layout.labels.suffix,
                  r: e.value.style.chart.legend.roundingValue
                }),
                { datapoint: l }
              )) + " ", 1),
              b.value.includes(l.id) ? (v(), y("span", fl, " ( - % ) ")) : (v(), y("span", hl, " (" + Y(isNaN(l.value / J.value) ? "-" : (l.value / J.value * 100).toFixed(e.value.style.chart.legend.roundingPercentage)) + "%) ", 1))
            ], 12, vl)
          ]),
          _: 1
        }, 8, ["legendSet", "config", "id"])) : $(t.$slots, "legend", {
          key: 1,
          legend: Ve.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (v(), y("div", {
        key: 8,
        ref_key: "source",
        ref: be,
        dir: "auto"
      }, [
        $(t.$slots, "source", {}, void 0, !0)
      ], 512)) : _("", !0),
      ge(It, {
        show: F.value.showTooltip && I.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: T.value,
        content: A.value,
        isFullscreen: w.value,
        isCustom: m(Ye)(e.value.style.chart.tooltip.customFormat)
      }, {
        "tooltip-before": x(() => [
          $(t.$slots, "tooltip-before", X(j({ ...he.value })), void 0, !0)
        ]),
        "tooltip-after": x(() => [
          $(t.$slots, "tooltip-after", X(j({ ...he.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
      h.value ? (v(), q(Pt, {
        key: 9,
        hideDetails: "",
        config: {
          open: F.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: x(() => [
          (v(), q(At, {
            key: `table_${Ce.value}`,
            colNames: ne.value.colNames,
            head: ne.value.head,
            body: ne.value.body,
            config: ne.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: o[2] || (o[2] = (l) => F.value.showTable = !1)
          }, {
            th: x(({ th: l }) => [
              O("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, pl)
            ]),
            td: x(({ td: l }) => [
              ie(Y(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : _("", !0)
    ], 46, Zt));
  }
}, Fl = /* @__PURE__ */ Ut(gl, [["__scopeId", "data-v-5e08c158"]]);
export {
  Fl as default
};
